package com.example.unimag_sdk_tutorial;

import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import com.example.unimag_sdk_tutorial.R;
import com.idtechproducts.device.*;
import com.idtechproducts.device.ReaderInfo.DEVICE_TYPE;

public class MainActivity extends Activity implements  OnReceiverListener, OnReceiverListenerPIN, OnReceiverListenerPINRequest{

	// declaring the instance of the UniPayReader;
	private IDT_UniMag myUniMagReader = null;
	private TextView connectStatusTextView;  
	private TextView textLog;
	private TextView lcdLog;
	private Button btnGetFirmware;
	private Handler handler = new Handler();
    private boolean isReaderConnected = false;
    private String info = "";
	private String detail = "";
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		handler = new Handler();		
		btnGetFirmware = (Button)findViewById(R.id.btn_getFirmware);
	    textLog = (TextView)findViewById(R.id.textLog);
	    lcdLog = (TextView)findViewById(R.id.lcdLog);
	    connectStatusTextView = (TextView)findViewById(R.id.status_text);
		if(myUniMagReader!=null){
			myUniMagReader.unregisterListen();
			myUniMagReader.release();
			myUniMagReader = null;
		}
		myUniMagReader = new IDT_UniMag(this,this);
		myUniMagReader.device_setDeviceType(DEVICE_TYPE.DEVICE_UNIMAG);
		myUniMagReader.registerListen();
//		loadXMLfile();
		

		btnGetFirmware.setOnClickListener(new Button.OnClickListener(){  
	        public void onClick(View v) {
	        	info = "Getting Firmware\n";
	        	detail = "";
	        	handler.post(doUpdateStatus);
	        	StringBuilder sb = new StringBuilder();
	            int ret = myUniMagReader.device_getFirmwareVersion(sb);
	            if (ret == ErrorCode.SUCCESS) {
					info += "Firmware Version: " + sb.toString();
					detail = "";
					handler.post(doUpdateStatus);
				}
				else {
					info += "GetFirmwareVersion: Failed\n";
					info += "Status: "+ myUniMagReader.device_getResponseCodeString(ret)+"";
					detail = "";
					handler.post(doUpdateStatus);							
					}
	        }  
	    });
		
	}

	@Override
	public void ICCNotifyInfo(byte[] arg0, String arg1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void LoadXMLConfigFailureInfo(int arg0, String arg1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void autoConfigCompleted(StructConfigParameters arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void autoConfigProgress(int arg0) {
		// TODO Auto-generated method stub
		
	}
	
	private Runnable doUpdateLabel = new Runnable()
	{
	    public void run()
	    {
	        if(!isReaderConnected){
	            connectStatusTextView.setText("UNIMAG USB DISCONNECTED");
	        }
	        else{
	            connectStatusTextView.setText("UNIMAG USB CONNECTED");
	        }
	    }
	};
	@Override
	public void deviceConnected() {
		isReaderConnected = true;
		handler.post(doUpdateLabel);		
	}

	@Override
	public void deviceDisconnected() {
		isReaderConnected = false;
	    handler.post(doUpdateLabel);		
	}
	
	
	@Override
	public void emvTransactionData(IDTEMVData emvData) {
	
	}

	public void lcdDisplay(int mode, String[] lines, int timeout) {
		
	}


	@Override
	public void msgAudioVolumeAjustFailed() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void msgRKICompleted(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void msgToConnectDevice() {
		// TODO Auto-generated method stub
		
	}

	private Runnable doUpdateStatus = new Runnable()
	{
		public void run()
		{		
			lcdLog.setText(info);
			textLog.setText(detail);
		}
	};
	@Override
	public void swipeMSRData(IDTMSRData card) {
		
		if (card.result != ErrorCode.SUCCESS)
		{
			info = "MSR card data didn't read correctly\n";
			info += ErrorCodeInfo.getErrorCodeDescription(card.result);
			if (card.result != ErrorCode.FAILED_NACK)
			{
				detail = "";
				handler.post(doUpdateStatus);
				return;
			}
		}
		else
		{
			info = "MSR Card tapped/Swiped Successfully";
		}
		info = new String(card.cardData);
		detail = Common.getHexStringFromBytes(card.cardData);
		handler.post(doUpdateStatus);
		
	}

	@Override
	public void timeout(int arg0) {
		// TODO Auto-generated method stub
		
	}
	
	private String getXMLFileFromRaw(String fileName ,int res){
		//the target filename in the application path
		String fileNameWithPath = null;
		fileNameWithPath = fileName;
		String newFilename = fileName;
	
		try {
			InputStream in = getResources().openRawResource(res);
			int length = in.available();
			byte [] buffer = new byte[length];
			in.read(buffer);    	   
			in.close();
			deleteFile(fileNameWithPath);
			FileOutputStream fout = openFileOutput(fileNameWithPath, MODE_PRIVATE);
			fout.write(buffer);
			fout.close();
    	   
			// to refer to the application path
			File fileDir = this.getFilesDir();
			fileNameWithPath = fileDir.getParent() + java.io.File.separator + fileDir.getName();
			fileNameWithPath += java.io.File.separator+newFilename;
	   	   
		} catch(Exception e){
			e.printStackTrace();
			fileNameWithPath = null;
		}
		return fileNameWithPath;
	}
	
//	private String getConfigurationFileFromRaw( ){
//		return getXMLFileFromRaw("idt_unimagcfg_default.xml",R.raw.idt_unimagcfg_default);
//	}
//	private boolean isFileExist(String path) {
//    	if(path==null)
//    		return false;
//	    File file = new File(path);
//	    if (!file.exists()) {
//	      return false ;
//	    }
//	    return true;
//    }
//	private void loadXMLfile(){
//
//	}

	@Override
	public void dataInOutMonitor(byte[] arg0, boolean arg1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void msgBatteryLow() {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void ctlsEvent(byte event, byte scheme, byte data){
			
	}

	@Override
	public void lcdDisplay(int arg0, String[] arg1, int arg2, byte[] arg3,
			byte arg4) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void pinpadData(final byte[] data){

	}
	
	public void pinRequest(final int mode, final byte[] key, final byte[] PAN, final int startTO,
			final int intervalTO, final String language) {

	}
	
}
